various fixes, data subvols changed, mostly handled elsewhere now
[automated-distro-installer] / fai / config / scripts / GRUB_PC / 11-ian
index d22d8fc852df9bf871c15cecdd1627116dfbc74a..a10efef37e185b42fd8e8a5d40c22b57a4b07a6c 100755 (executable)
@@ -1,43 +1,94 @@
 #!/bin/bash -x
 
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
-$ROOTCMD adduser --disabled-password --gecos ian ian
-$ROOTCMD usermod -p "$ROOTPW" ian
+if [[ $EUID != 0 ]]; then
+  echo "$0: error: expected to be root."
+  exit 1
+fi
+
+if ! type -t fcopy &>/dev/null; then
+  sudo apt-get -y install fai-client
+fi
 
-if ifclass STABLE; then
-    fcopy -M /etc/apt/preferences
+chroot $FAI_ROOT bash <<'EOFOUTER'
+if getent group systemd-journal >/dev/null; then
+  # makes the journal be saved to disk.
+  mkdir -p /var/log/journal
+  chmod 755 /var/log/journal
 fi
+debconf-set-selections <<EOF
+kexec-tools kexec-tools/load_kexec boolean false
+EOF
+apt-get install -y pxe-kexec
+EOFOUTER
 
-if ifclass DEBIAN; then
-    fcopy -M /etc/apt/preferences.d/unstable
-    fcopy -riM /etc/apt/sources.list.d
+# note: # fcopy -i = ignore nonmatching class error, always return 0.
+# this is also done by FABASE/10-misc by default.
+fcopy -ir /root
+if ifclass STABLE_BOOTSTRAP; then
+  fcopy -ri /etc/systemd/system
+  chroot $FAI_ROOT bash <<'EOFOUTER'
+systemctl enable fai_check.service
+EOFOUTER
+  exit 0
 fi
 
+dir=/q/root/shadow
+fai_shadow=$FAI/distro-install-common/shadow
+if [[ ! -e $dir && -e $fai_shadow ]]; then
+  mkdir -p $dir
+  mount -o bind $fai_shadow $dir
+fi
+$FAI/distro-install-common/end
+
+
+# these get copied in an earlier stage by fai, but leaving it here since
+# I run this as a single post-fai script to update things that have changed.
+fcopy -ri /etc/apt/preferences.d
+fcopy -ri /etc/apt/sources.list.d
+$ROOTCMD apt-get update
 
-# -i, ignore nonmatching class error, always return 0.
-fcopy -r -M -i /home/ian/.ssh
-/var/lib/fai/config/distro-install-common/end
 
-rm -f /target/etc/apt/sources.list
 
-chroot /target bash <<'EOF'
+rm -f $FAI_ROOT/etc/apt/sources.list
+
+chroot $FAI_ROOT bash <<'EOF'
+set -eE -o pipefail
+mkdir -p /home/ian/.ssh
+f=/root/.ssh/authorized_keys
+if [[ -e $f ]]; then
+   cp $f /home/ian/.ssh
+fi
 chown -R 1000:1000 /home/ian/.ssh
 chmod -R u=Xrw,og= /home/ian/.ssh
-cp -ar /home/ian/.ssh /root
+rm -rf /root/.ssh
+cp -rL /home/ian/.ssh /root
 chown -R root:root /root/.ssh
+chmod 700 /root/.ssh
 
-# default jessie groups + kvm & systemd-journal
-usermod -aG cdrom,floppy,sudo,audio,dip,video,plugdev,netdev,kvm,systemd-journal ian
-EOF
 
+# default jessie groups + kvm, systemd-journal, adm
+usermod -aG adm,cdrom,floppy,sudo,audio,dip,video,plugdev,netdev ian
 
-$ROOTCMD apt-get -y install unison-gtk
-if ifclass STABLE; then
-    # don't think this is needed since I figured out how to
-    # deal with mismatching unison compilers, but I don't
-    # see any reason to revert it, since it only installs
-    # a single package which is primarily a single binary
-    $ROOTCMD apt-get -y install unison-gtk/testing
+if getent group systemd-journal >/dev/null; then
+  usermod -aG systemd-journal ian
 fi
+# https://askubuntu.com/questions/33416/how-do-i-disable-the-boot-splash-screen-and-only-show-kernel-and-boot-text-inst
+# it suggests not having plymouth-theme-ubuntu-text, but
+# making it not installed then kills plymouth, then makes
+# the system not boot.
+sed -ri 's/(^ *GRUB_CMDLINE_LINUX.*)quiet splash/\1/' /etc/default/grub
+# on xenial, no grub is displayed at all. fix that.
+# found just by noticing this in the config file, and a
+# warning about it in error.log
+sed -i '/^ *GRUB_HIDDEN_TIMEOUT/d' /etc/default/grub
+update-grub2
+EOF
+
+
+# reading through the groups that ian is in but traci isn't,
+for g in plugdev audio video cdrom; do
+    $ROOTCMD usermod -a -G $g traci
+done